#region usings
using System;
using System.ComponentModel.Composition;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;
using VVVV.Core.Logging;
using System.Collections.Specialized;
using System.Linq;
using System.Diagnostics;
using System.Threading;



#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "AliveTime", Category = "ID", Version = "0.3", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo

	public class C0_3IDAliveTimeNode : IPluginEvaluate
	{
		#region fields & pins


		[Input("Key", DefaultValue = 0.0,Order=0)]
		ISpread<int> FKey;

		[Input("RemoveKey", DefaultValue = 0.0,Order=1)]
		ISpread<int> FRemoveKey;

		[Input("Reset", DefaultValue = 0, IsSingle = true,Order=2)]
		ISpread<bool> FReset;

		[Output("KeyOut", DefaultValue = 0.0,Order=0)]
		ISpread<int> FKeyOut;

		[Output("AliveTime", DefaultValue = 0.0,Order=1)]
		ISpread<double> FValueOut;

		[Output("Count", IsSingle = true,Order=2)]
		ISpread<int> FDictiCount;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested

		int countAdd = 0;
		int dicount = 0;
		int countRemove = 0;
		int GetKeyFoundCount = 0;




		Dictionary<int, Stopwatch> Dicti = new Dictionary<int, Stopwatch>();

		public void Evaluate(int SpreadMax)
		{

			countAdd = FKey.SliceCount;
			countRemove = FRemoveKey.SliceCount;

			//////////

			for (int i = 0; i < countAdd; i++) {

				if (!Dicti.ContainsKey(FKey[i])) {
					Stopwatch stopWatch = new Stopwatch();
					stopWatch.Start();
					Dicti.Add(FKey[i], stopWatch);
				}

			}


			///////////// 

			for (int i = 0; i < countRemove; i++) {

				if (Dicti.ContainsKey(FRemoveKey[i])) {
					Dicti.Remove(FRemoveKey[i]);
				}

			}


			dicount = Dicti.Count;
			FKeyOut.SliceCount = dicount;
			FValueOut.SliceCount = dicount;
			


			int counter = 0;


			foreach (var seconds in Dicti.Values) {

				TimeSpan ts = seconds.Elapsed;

				FValueOut[counter] = ts.TotalSeconds;
				counter++;

			}





			List<int> keys = Dicti.Keys.ToList();
			//List<double> values = Dicti.Values.ToList();

			FKeyOut.AssignFrom(keys);
			//FValueOut.AssignFrom(values);



			if (FReset[0]) {
				Dicti.Clear();
			}
			FDictiCount[0] = dicount;





		}
	}
}
